import Foundation
import IndoorLocation

public class FlutterLocationListener: ILIndoorLocationProviderDelegate {
    var _channel: FlutterMethodChannel!
    var _locationFields = ["accuracy", "floor", "latitude", "longitude", "providerName"]
    
    init(channel: FlutterMethodChannel) {
        _channel = channel
        hash = 42
        description = ""
    }
    
    public func provider(_ provider: ILIndoorLocationProvider!, didUpdate location: ILIndoorLocation!) {
        _channel.invokeMethod("locationCallback", arguments: _locationFields.reduce([String: Any]()) { (dict, field) -> [String: Any] in
            var dict = dict
            dict[field] = location.value(forKey: field)
            return dict
        })
    }
    
    public func provider(_ provider: ILIndoorLocationProvider!, didFailWithError error: Error!) {}
    
    public func providerDidStart(_ provider: ILIndoorLocationProvider!) {
        _channel.invokeMethod("onProviderStarted", arguments: nil)
    }
    
    public func providerDidStop(_ provider: ILIndoorLocationProvider!) {
        _channel.invokeMethod("onProviderStopped", arguments: nil)
    }
    
    public func isEqual(_ object: Any?) -> Bool { return false }
    
    public var hash: Int
    
    public var superclass: AnyClass?
    
    public func `self`() -> Self { return self }
    
    public func perform(_ aSelector: Selector!) -> Unmanaged<AnyObject>! {
        return Unmanaged.passRetained(self)
    }
    
    public func perform(_ aSelector: Selector!, with object: Any!) -> Unmanaged<AnyObject>! {
        return Unmanaged.passRetained(self)
    }
    
    public func perform(_ aSelector: Selector!, with object1: Any!, with object2: Any!) -> Unmanaged<AnyObject>! {
        return Unmanaged.passRetained(self)
    }
    
    public func isProxy() -> Bool { return false }
    
    public func isKind(of aClass: AnyClass) -> Bool { return false }
    
    public func isMember(of aClass: AnyClass) -> Bool { return false }
    
    public func conforms(to aProtocol: Protocol) -> Bool { return false }
    
    public func responds(to aSelector: Selector!) -> Bool { return false }
    
    public var description: String
}

