import Flutter
import UIKit
import IndoorLocation

public class SwiftBleProviderPlugin: NSObject, FlutterPlugin {
    var provider: ILPolestarIndoorLocationProvider?
    static var channel: FlutterMethodChannel = FlutterMethodChannel()
    
  public static func register(with registrar: FlutterPluginRegistrar) {
    channel = FlutterMethodChannel(name: "ble_provider", binaryMessenger: registrar.messenger())
    let instance = SwiftBleProviderPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      switch(call.method) {
      case "getPlatformVersion":
          result("iOS " + UIDevice.current.systemVersion)
          break;
      case "init":
          if let args = call.arguments as? Dictionary<String, Any>,
              let polestarKey = args["key"] as? String {
              provider = ILPolestarIndoorLocationProvider(polestarKey: polestarKey)
              result(true)
            } else {
              result(FlutterError.init(code: "bad args", message: nil, details: nil))
            }
          break;
      case "start":
          provider?.start()
          result(provider?.isStarted())
          provider?.dispatchDidStart()
          break;
      case "setLocationCallback":
          provider?.addDelegate(FlutterLocationListener(channel: SwiftBleProviderPlugin.channel))
          result(provider != nil ? provider!.delegates.count == 1 : false)
          break;
      case "stop":
          provider?.stop()
          result(!(provider?.isStarted() ?? true))
          provider?.dispatchDidStop()
          break;
      default:
          print("Method not implemented: " + call.method)
          result(false)
          break;
      }
  }
}
